// This just works with one variable from the Game Dash.

#include <LiquidCrystal.h>
LiquidCrystal lcd(4,5,6,7,8,9);
int Speed = 0;
int SpeedGameDash = 0;
int MaxSpeed = 0;
int PotReading = 0;
int bufferArray[4];


void setup(){
  
  pinMode(11,OUTPUT);
  lcd.begin(16, 2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Wind Control by");
  lcd.setCursor(0,1);
  lcd.print("Ministrinity");
  delay(2000);
  lcd.clear();
  Serial.begin(9600);
}

void loop(){ 
  //****************************** READ DATA FROM SERIAL ******************************
  
  
  if (Serial.available() == 4)  {    //if 4 bits available in the Serial buffer...
        
        int i;
        for (i=0; i<4; i=i+1) {       // read and label each byte.
         bufferArray[i] = Serial.read();
         }
        
         if (bufferArray[0]  == 'S'){
           SpeedGameDash = ((bufferArray[1]-48)*100) + ((bufferArray[2]-48)*10) + // Take values 1-3.
                               ((bufferArray[3]-48)*1);  
            if (SpeedGameDash < 0){SpeedGameDash = 0;}
CheckPot();
CalcPWM();
DisplayLcd();     
   }
  }
}
void CheckPot(){
    PotReading = analogRead(0);
    MaxSpeed = map(PotReading, 0, 1023, 0, 400);
                 
 }


void CalcPWM() {
    
    Speed = map(SpeedGameDash, 0 ,MaxSpeed, 0 , 255);
    if (Speed <= 0 ){Speed = 0;}
    if (Speed > 255){Speed = 255;}
    if (SpeedGameDash == 0){Speed = 0;}
    analogWrite(11,Speed);
}
void DisplayLcd() {
             lcd.clear();
             lcd.setCursor(0,0);
             lcd.print("Car:");     
             lcd.print(SpeedGameDash);
             lcd.setCursor(9,0);
             lcd.print("Fan:");
             lcd.print(Speed);
             lcd.setCursor(0,1);
             lcd.print("Max:");
             lcd.print(MaxSpeed);
          
}
